package com.reyun.sdktestdemo;

import android.util.Base64;
import android.util.Log;
import android.widget.TextView;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInput;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.channels.SocketChannel;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.KeyFactory;
import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.PKCS8EncodedKeySpec;
import java.util.zip.DataFormatException;
import java.util.zip.Deflater;
import java.util.zip.DeflaterInputStream;
import java.util.zip.GZIPInputStream;
import java.util.zip.Inflater;
import java.util.zip.ZipInputStream;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

public class HttpServer extends NanoHTTPD {
    private TextView mTextView;
    public HttpServer(int port, TextView textView) {
        super(port);
        mTextView = textView;
    }

    private String m_RSAPrivateKey=/*"-----BEGIN RSA PRIVATE KEY-----\n" +*/
            "MIICXQIBAAKBgQDWuIwr3n0x5rgCVhPtwJVeg0NSQBOcu+nND4rNIqqBc3+eQLuT\n" +
            "Dn19IfzX0n2lGRsY9x9EUn8WA4TTWA+Q4he/5NlEFBWaW2O7fz25pIeoilnTtJVt\n" +
            "fc8KU1+i8rCKtWDS9jvabJWjDVcVIcASArkA8TL9AKqRAzC0RlTLRpj5jQIDAQAB\n" +
            "AoGAWbI0E+tYXy0jNw6gOpRVkWrCB6zuxG2XSGsyr2jI01TdPc2Kze6iq1A0YC/0\n" +
            "/q/TKwWokRDpN9f2d5b0wbBA/MtXkISGMJsEbOInGQr6HOO2Y9uUQYnFClmS7taV\n" +
            "h1y3rSVqvUffR2TcTxSRYn7iPXNSxMoxPWMDuIYsbyqjUR0CQQD1NLlYpHBYmOzP\n" +
            "AOZe0cgPPtan53KS0XIrFJPymEHSX/ewiHpgrxxdqu9EjCmNhDifw2GLiwCXtOB7\n" +
            "rzUvkDmPAkEA4CxH90DT+KCiu9U5g7cE2SUcNQJQoNBQ7PyvSfayXN02TXQjROhk\n" +
            "0N74fp0pTc3MOLXI6aUPzhQodKzGImG1IwJBAMS6PEomBAzRBI1AB5Pjc0LoA4hK\n" +
            "ZN3uNE7j/58PESAb5rk3hhez5mowDi9M1Lm5b0SemNBAAYW1lLUm6OD0MXkCQFa4\n" +
            "qqp7GMWBFxNE/Hf48FY0pgHXwGtFy1iys/kQB5YnOZ+jAxXgNUgcSdNpZxYjPBLg\n" +
            "ODYy1bdqUvA3+npIhDMCQQDCuRfbht8EqB1LeTi0/4TVb5X7JFUlCp2askCBUetO\n" +
            "zcfineSbkroY9/QTItUEkGtOxfWxHAMQ/Lle/rKBxXhm\n";
            /*"-----END RSA PRIVATE KEY-----";*/


    @Override
    public Response serve(IHTTPSession session) {
        if(!session.getMethod().equals(Method.POST)) return newFixedLengthResponse("not support GET");
        if(!(session instanceof HTTPSession)) return newFixedLengthResponse("not support such method");
        Log.d("wd_collect", "serve start...");
        try{
            int len = (int) ((HTTPSession)session).getBodySize();
            byte[] b = new byte[(int) len];
            InputStream in = session.getInputStream();
            in.read(b, 0, len);
            ByteBuffer bb = ByteBuffer.wrap(b);
            bb.order(ByteOrder.LITTLE_ENDIAN);
            byte[] encodedkey = new byte[128];
            byte[] encodediv = new byte[128];
            byte[] data_md5 = new byte[16];
            int ts;
            int data_len;
            bb.get(encodedkey, 0, 128);
            bb.get(encodediv, 0, 128);
            PKCS8EncodedKeySpec keySpec = new PKCS8EncodedKeySpec(Base64.decode(m_RSAPrivateKey, Base64.DEFAULT));
            KeyFactory keyFactory = KeyFactory.getInstance("RSA");

            Cipher cipher2 = Cipher.getInstance("RSA/ECB/PKCS1Padding");
            cipher2.init(Cipher.DECRYPT_MODE, keyFactory.generatePrivate(keySpec));
            byte[] key =  cipher2.doFinal(encodedkey);
            byte[] iv =  cipher2.doFinal(encodediv);
            ts = bb.getInt();
            bb.get(data_md5, 0, 16);
            data_len = bb.getInt();
            final byte[] data = new byte[data_len];
            bb.get(data, 0, data_len);
            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS7Padding");
            SecretKeySpec skeySpec = new SecretKeySpec(key, "AES");
            cipher.init(Cipher.DECRYPT_MODE, skeySpec, new IvParameterSpec(iv));
            byte[] decodedData = cipher.doFinal(data);
            Inflater inflater = new Inflater();
            inflater.setInput(decodedData);
            byte[] buf = new byte[1024];
            ByteArrayOutputStream bo2 = new ByteArrayOutputStream();
            while(!inflater.finished()){
                int n = inflater.inflate(buf, 0, 1024);
                bo2.write(buf, 0, n);
            }
            byte[] ori_data = bo2.toByteArray();
            final String xxx = new String(ori_data);
            Log.d("wdsdk", "serve: " + xxx);
            mTextView.post(new Runnable() {
                @Override
                public void run() {
                    mTextView.setText(xxx);
                }
            });
        } catch (IOException e) {
            e.printStackTrace();
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        } catch (NoSuchPaddingException e) {
            e.printStackTrace();
        } catch (BadPaddingException e) {
            e.printStackTrace();
        } catch (IllegalBlockSizeException e) {
            e.printStackTrace();
        } catch (InvalidAlgorithmParameterException e) {
            e.printStackTrace();
        } catch (InvalidKeyException e) {
            e.printStackTrace();
        } catch (DataFormatException e) {
            e.printStackTrace();
        } catch (InvalidKeySpecException e) {
            e.printStackTrace();
        }
        return newFixedLengthResponse("hahaha...");
    }
}
